Educational Codeforces Round 120 (Rated for Div. 2)(A-C)
知识点整理:
题号 | 知识点 | 备注 |
---|---|---|
A | 无 | |
B | 贪心,排序 | |
C | 贪心,二分,三分,前缀和 | |
D | 组合数学,双指针 | |
E | 位运算 | |
F | 构造,数论,哈希 |
A - Construct a Rectangle
题意
给你三根木棍,折断其中一根变成四根,边长均必须为整数,问可否构成矩形
题解
两种情况:
- 最长的等于两个短的之和
- 有两根相等,另一根是偶数
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
int t;
ll a[3];
int main() {
#ifdef LOCAL
freopen("in.txt", "r", stdin);
freopen("out.txt", "w", stdout);
#endif
cin >> t;
while (t--) {
cin >> a[0] >> a[1] >> a[2];
sort(a, a+3);
if (a[0] + a[1] == a[2]) cout << "YES" << endl;
else {
if (a[0] == a[1] && a[2] % 2 == 0) {
cout << "YES" << endl;
} else if (a[1] == a[2] && a[0] % 2 == 0) {
cout << "YES" << endl;
} else {
cout << "NO" << endl;
}
}
}
return 0;
}
B. Berland Music
题意
有 n n n首歌,他们的好听程度是 n n n的排列, 现在有一个评委对这n首歌打分,可以是喜欢可以是不喜欢,要求输出一个歌曲的排名,满足喜欢的分数必须高于不喜欢的,且与原始排列差值的绝对值和最小。
题解
先排喜欢的,记录原来的顺序从高到低排,再排不喜欢的,用map维护
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const int N = 2e5 + 5;
int t, n;
int p[N];
string s;
int main() {
#ifdef LOCAL
freopen("in.txt", "r", stdin);
freopen("out.txt", "w", stdout);
#endif
cin >> t;
while (t--) {
cin >> n;
map<int, int> rk0, rk1;
for (int i = 0; i < n; i++) {
cin >> p[i];
}
string s;
cin >> s;
for (int i = 0; i < n; i++) {
if (s[i] == '0') rk0[-p[i]] = i;
else rk1[-p[i]] = i;
}
vector<int> ans(n + 1, 0);
int temp = n;
for (auto [k, v] : rk1) {
ans[v+1] = temp--;
}
for (auto [k, v] : rk0) {
ans[v+1] = temp--;
}
for (int i = 1; i <= n; i++) cout << ans[i] << ' ';
cout << endl;
}
return 0;
}
C. Set or Decrease
题意
给你一个数组,可进行如下操作:
- 把一个元素减一
- 把一个元素的值变成另一个
问使得数组的和小于等于 K K K的最小操作次数
题解
首先贪心考虑,要想把和减小,把大的元素变成最小的才下降更快,但如果不够变,则需要把最小的数变得更小,再变大的元素。
所以先排序并求前缀和,枚举一个点
i
i
i, 考虑两种情况:
- 把 a i + 1 , . . . , a n a_{i+1},...,a_n ai+1,...,an都变成 a 1 a_1 a1, 需要 n − i n-i n−i步
- 方案一如果搞不定,则要把 a 1 a_1 a1变成 b b b,再把 a i + 1 , . . . , a n a_{i+1},...,a_n ai+1,...,an都变成 b b b,需要 a 1 − b + n − i a_1 - b + n - i a1−b+n−i步
观察第二种方案,要想使得操作数最少,需要 b b b越大越好,所以求最大的 b b b, b b b满足:
修改后的数组为
b
,
a
2
,
.
.
.
,
a
i
,
b
,
b
,
.
.
.
,
b
b, a_2, ..., a_i, b, b, ..., b
b,a2,...,ai,b,b,...,b 则他们的和就是
s
u
m
i
−
a
1
+
(
n
−
i
+
1
)
b
sum_i-a_1+(n-i+1)b
sumi−a1+(n−i+1)b需要满足小于等于
K
K
K, 则
b
≤
k
+
a
1
−
s
u
m
i
n
−
i
+
1
b\le \frac{k+a_1-sum_i}{n-i+1}
b≤n−i+1k+a1−sumi, 向下取整即可 需要注意不能直接用除号, 要用floor
函数
以上所有方案取min即可,总的时间复杂度为 O ( n ) O(n) O(n)
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
typedef pair<int, int> pii;
const int MAXN = 2e5 + 10;
const int MOD = 1e9 + 7;
int t, n;
ll k, a[MAXN], sum[MAXN];
int main() {
#ifdef LOCAL
freopen("in.txt", "r", stdin);
freopen("out.txt", "w", stdout);
#endif
ios::sync_with_stdio(false), cin.tie(0);
cin >> t;
while (t--) {
cin >> n >> k;
for (int i = 1; i <= n; i++) cin >> a[i];
sort(a + 1, a + 1 + n);
for (int i = 1; i <= n; i++) sum[i] = sum[i - 1] + a[i];
ll ans = 1e16;
for (ll i = n; i >= 1; i--) {
if (sum[i] + (n - i) * a[1] <= k) {
ans = min(ans, n - i);
continue;
}
int b = floor((k + a[1] - sum[i]) * 1.0 / (n - i + 1));
if (b < a[1]) {
ans = min(ans, a[1] - b + n - i);
}
}
cout << ans << endl;
}
return 0;
}